package space.kklochko.jdbc_hospital_example.db.repositories;

import lombok.Setter;
import space.kklochko.jdbc_hospital_example.db.factories.DataBaseConnection;

import java.util.ArrayList;
import java.util.UUID;

@Setter
public abstract class AbstractRepository<T> {
    DataBaseConnection db;

    public AbstractRepository(DataBaseConnection db){
        setDb(db);
    }

    public abstract boolean createTable();

    public abstract boolean create(T object);

    public abstract T read(UUID id);

    public abstract ArrayList<T> readAll();

    public abstract boolean update(T object);

    public abstract boolean delete(UUID id);
}
